unit gflooker;
	{ This is the map cursor browser tool thingie. }
{
	GearHead: Arena, a roguelike mecha CRPG
	Copyright (C) 2005 Joseph Hewitt

	This library is free software; you can redistribute it and/or modify it
	under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation; either version 2.1 of the License, or (at
	your option) any later version.

	The full text of the LGPL can be found in license.txt.

	This library is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
	General Public License for more details. 

	You should have received a copy of the GNU Lesser General Public License
	along with this library; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
}
	{ As far as I remember, this unit is called "gflooker" because the original }
	{ version of this program was going to be an arena battle game called }
	{ GearFight. That didn't last long before I jumped into making it a fully }
	{ featured RPG instead. }

interface

uses
{$IFDEF PATCH_GH}
	gears_base,
{$ENDIF PATCH_GH}
	gears,locale;

const
	LOOKER_AutoSelect: Boolean = True;	{ Auto select new target if no current target. }

var
	LOOKER_X,LOOKER_Y: Integer;	{ Last X , Y position accessed. }
	LOOKER_Gear: GearPtr;		{ Last mecha accessed. }
{$IFDEF PATCH_GH}
{$ELSE PATCH_GH}
	LOOKER_LastGearSelected: GearPtr;	{ Last enemy selected with select next enemy key. }
{$ENDIF PATCH_GH}
{$IFDEF PATCH_HEART}
	Flag_GetMekInput_Forced2Pause: Boolean;
	Flag_Pause_LookAround4QRL: Boolean;
{$ENDIF PATCH_HEART}

Procedure DisplayTileInfo( GB: GameBoardPtr; X,Y: Integer; ShowEmpty: Boolean );

Function LookAround( GB: GameBoardPtr; Mek: GearPtr ): Boolean;
Function SelectTarget( GB: GameBoardPtr; Mek: GearPtr; var Wpn: GearPtr; var CallShot: boolean; var RapidFire: Integer ): Boolean;
{$IFDEF PATCH_HEART}
Function LookAround4QRL( Camp: CampaignPtr; GB: GameBoardPtr; Mek: GearPtr ): Boolean;
Procedure Init_LookAround4QRL;
{$ENDIF PATCH_HEART}

implementation

uses
{$IFDEF DEBUG}
	errmsg,
{$ENDIF DEBUG}
{$IFDEF PATCH_GH}
	pseudosmartpointer,
{$ENDIF PATCH_GH}
{$IFDEF PATCH_I18N}
	i18nmsg,
{$ENDIF PATCH_I18N}
{$IFDEF PATCH_GH}
	ui4gh,
	ability,damage,gearutil,ghweapon,menugear,texutil,
{$ELSE PATCH_GH}
	ability,damage,gearutil,ghweapon,menugear,texutil,ui4gh,
{$ENDIF PATCH_GH}
{$IFDEF PATCH_CHEAT}
	backpack,pcaction,
{$ENDIF PATCH_CHEAT}
{$IFDEF PATCH_HEART}
	qrl,
{$ENDIF PATCH_HEART}
{$IFDEF SDLMODE}
	sdlgfx,sdlinfo,sdlmap,sdlmenus
{$ELSE}
	congfx,coninfo,conmap,conmenus,context
{$ENDIF}
	;

var
{$IFDEF PATCH_GH}
	LOOKER_LastGearSelected: GearPtr;	{ Last enemy selected with select next enemy key. }
{$ELSE PATCH_GH}
{$ENDIF PATCH_GH}
	LOOKER_Origin,LOOKER_Weapon: GearPtr;
	LOOKER_CallShot: Boolean;
	LOOKER_RapidFire: Integer;
{$IFDEF SDLMODE}
	LOOKER_GB: GameBoardPtr;
	LOOKER_Desc: String;
{$ENDIF}
{$IFDEF PATCH_GH}
  {$IFDEF SDLMODE}
  {$ELSE SDLMODE}
	LOOKER_Desc: String;
  {$ENDIF}
{$ENDIF PATCH_GH}
{$IFDEF PATCH_HEART}
	LookAround4QRL_FixedTarget: Boolean;
	LookAround4QRL_X,LookAround4QRL_Y: Integer;
  {$IFDEF SDLMODE}
	LookAround4QRL_Target_X,LookAround4QRL_Target_Y: Integer;
  {$ENDIF SDLMODE}
{$ENDIF PATCH_HEART}


Procedure DoSwitchBV;
	{ Switch the burst value used for LOOKER_Weapon, then store the }
	{ new burst value as the weapon's default. }
var
	BV: Integer;
begin
{$IFDEF PATCH_GH}
	if (NIL = LOOKER_Weapon) or (LOOKER_Weapon^.G <= GG_DisposeGear) then Exit;
{$ELSE PATCH_GH}
	if LOOKER_Weapon = Nil then Exit;
{$ENDIF PATCH_GH}

	{ Determine the current BV; this will tell us what to do next. }
	BV := WeaponBVSetting( LOOKER_Weapon );
	if LOOKER_Weapon^.G = GG_Weapon then begin
		if LOOKER_Weapon^.S = GS_Missile then begin
			BV := BV + 1;
			if BV > 4 then BV := 1;
			SetNAtt( LOOKER_Weapon^.NA , NAG_Prefrences , NAS_DefAtOp , BV );
		end else if ( LOOKER_Weapon^.S = GS_Ballistic ) or ( LOOKER_Weapon^.S = GS_BeamGun ) then begin
			BV := 5 - BV;
			SetNAtt( LOOKER_Weapon^.NA , NAG_Prefrences , NAS_DefAtOp , BV );
		end;
	end;
end;

Procedure WeaponDisplay;
	{ Show the weapon display, and the instructions/options. }
var
	msg: String;
begin
	{ Generate instructions. }
{$IFDEF PATCH_I18N}
	msg := ReplaceHash( I18N_MsgString('WeaponDisplay_KeyMap','SwitchWeapon'), KeyMap[ KMC_SwitchWeapon ].KCode );
	msg := msg + #13 + ' ' + ReplaceHash( I18N_MsgString('WeaponDisplay_KeyMap','CalledShot'), KeyMap[ KMC_CalledShot ].KCode );
	if LOOKER_CallShot then begin
		msg := msg + I18N_MsgString('WeaponDisplay_KeyMap','CalledShot_On');
	end else begin
		msg := msg + I18N_MsgString('WeaponDisplay_KeyMap','CalledShot_Off');
	end;
	msg := msg + #13 + ' ' + ReplaceHash( I18N_MsgString('WeaponDisplay_KeyMap','SwitchBV'), KeyMap[ KMC_SwitchBV ].KCode );
	msg := msg + BVTypeName[ WeaponBVSetting( LOOKER_Weapon ) ];
	msg := msg + #13 + ' ' + ReplaceHash( I18N_MsgString('WeaponDisplay_KeyMap','SwitchTarget'), KeyMap[ KMC_SwitchTarget ].KCode );
{$ELSE PATCH_I18N}
	msg := '[' + KeyMap[ KMC_SwitchWeapon ].KCode + '] Change Weapon' + #13;
	msg := msg + ' [' + KeyMap[ KMC_CalledShot ].KCode + '] Called Shot: ';
	if LOOKER_CallShot then msg := msg + 'On'
	else msg := msg + 'Off';
	msg := msg + #13 + ' [' + KeyMap[ KMC_SwitchBV ].KCode + '] Burst Value: ';
	msg := msg + BVTypeName[ WeaponBVSetting( LOOKER_Weapon ) ];
	msg := msg + #13 + ' [' + KeyMap[ KMC_SwitchTarget ].KCode + '] Switch Target';
{$ENDIF PATCH_I18N}

	{ Print instructions. }
{$IFDEF SDLMODE}
	InfoBox( ZONE_Menu1.GetRect() );
	InfoBox( ZONE_Menu2.GetRect() );
	GameMSG( msg , ZONE_Menu2.GetRect() , NeutralGrey );
{$ELSE}
	GameMSG( msg , ZONE_Menu2 , NeutralGrey );
{$ENDIF}

	QuickWeaponInfo( LOOKER_Weapon );
end;

{$IFDEF SDLMODE}
Procedure GFLRedraw;
	{ menu redrawer for this unit. }
begin
	if LOOKER_GB <> Nil then SDLCombatDisplay( LOOKER_GB );
{$IFDEF PATCH_GH}
	if (NIL <> Looker_Weapon) and (GG_DisposeGear < Looker_Weapon^.G) then begin
		WeaponDisplay;
	end;
{$ELSE PATCH_GH}
	if LOOKER_Weapon <> Nil then WeaponDisplay;
{$ENDIF PATCH_GH}
	InfoBox( ZONE_TargetDistance.GetRect() );
	CMessage( LOOKER_Desc , ZONE_TargetDistance.GetRect() , InfoHilight );
	InfoBox( ZONE_TargetInfo.GetRect() );
end;
{$ENDIF}


Function CreateTileMechaMenu( GB: GameBoardPtr; X,Y: Integer; ShowAll: Boolean ): RPGMenuPtr;
	{ Make a menu listing each of the mecha at spot X , Y. }
var
	TMM: RPGMenuPtr;
	N,T: Integer;
	Mek: GearPtr;
	msg,PName: String;
begin
{$IFDEF SDLMODE}
	TMM := CreateRPGMenu( menuitem , menuselect , ZONE_TargetInfo );
{$ELSE}
	TMM := CreateRPGMenu( menuitem , menuselect , ZONE_Menu );
{$ENDIF}

	N := NumVisibleGears( GB , X , Y );

	for t := 1 to N do begin
		{ We need to list both the name of the mecha and the name of }
		{ the pilot. }
		Mek := FindVisibleGear( GB , X , Y , T );
		msg := GearName( Mek );
		PName := PilotName( Mek );
		if PName <> msg then msg := msg + ' - ' + PName;
		if not GearOperational( Mek ) then begin

{$IFDEF PATCH_I18N}
			if NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Gutted) = 1 then begin
				if NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Flayed) = 1 then begin
					msg := msg + I18N_MsgString('CreateTileMechaMenu', 'stripped');
				end else begin
					msg := msg + I18N_MsgString('CreateTileMechaMenu', 'gutted');
				end;
			end else begin
				if NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Flayed) = 1 then begin
					msg := msg + I18N_MsgString('CreateTileMechaMenu', 'flayed');
				end else begin
					msg := msg + I18N_MsgString('CreateTileMechaMenu', 'X');
				end;
			end;
			if NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Ransacked) = 1 then begin
				msg := msg + I18N_MsgString('CreateTileMechaMenu', 'looted');
			end else begin
				msg := msg + I18N_MsgString('CreateTileMechaMenu', '');
			end;
{$ELSE PATCH_I18N}
			if NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Gutted) = 1
			then begin
				if NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Flayed) = 1
				then
					msg := msg + ' (stripped'
				else
					msg := msg + ' (gutted';
			end
			else begin
				if NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Flayed) = 1
				then
					msg := msg + ' (flayed'
				else
					msg := msg + ' (X';
			end;

			if NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Ransacked) = 1
			then
				msg := msg + ', looted)'
			else
				msg := msg + ')';
{$ENDIF PATCH_I18N}
		end;
		if ShowAll or GearOperational( Mek ) then begin
			AddRPGMenuItem( TMM , msg , T );
		end;
	end;

	CreateTileMechaMenu := TMM;
end;

Procedure DisplayTileInfo( GB: GameBoardPtr; X,Y: Integer; ShowEmpty: Boolean );
	{ Display info on the contents of location X,Y. }
	{ If the tile is empty, give a description of the terrain. }
	{ Otherwise provide a sumamry for whatever gears are there. }
var
	N: Integer;	{ The number of gears present in the tile. }
	Mek: GearPtr;
	TMM: RPGMenuPtr;
	msg: String;
begin
	{ Display info for target square. }
	N := NumVisibleGears( GB , X , Y );
	if not OnTheMap( X , Y ) then begin
{$IFDEF PATCH_I18N}
		msg := I18N_MsgString('DisplayTileInfo','Off The Map');
  {$IFDEF SDLMODE}
		GameMSG( msg , ZONE_TargetInfo.GetRect() , StdWhite );
  {$ELSE}
		GameMSG( msg , ZONE_Info , StdWhite );
  {$ENDIF}
{$ELSE PATCH_I18N}
{$IFDEF SDLMODE}
		GameMSG( 'Off The Map' , ZONE_TargetInfo.GetRect() , StdWhite );
{$ELSE}
		GameMSG( 'Off The Map' , ZONE_Info , StdWhite );
{$ENDIF}
{$ENDIF PATCH_I18N}
		LOOKER_Gear := Nil;

	end else if ( N = 0 ) and ShowEmpty then begin
		if GB^.Map[X,Y].Visible then begin
			msg := '';
{$IFDEF PATCH_GH}
			if (NIL <> GB^.Scene) and (GG_DisposeGear < GB^.Scene^.G) then begin
				msg := SAttValue( GB^.Scene^.SA , 'LOOKER' + BStr( X ) + '%' + BStr( Y ) );
			end;
{$ELSE PATCH_GH}
			if GB^.Scene <> Nil then msg := SAttValue( GB^.Scene^.SA , 'LOOKER' + BStr( X ) + '%' + BStr( Y ) );
{$ENDIF PATCH_GH}
{$IFDEF PATCH_I18N}
			if msg = '' then msg := I18N_Name('TerrMan',TerrMan[GB^.map[X,Y].Terr].Name);
{$ELSE PATCH_I18N}
			if msg = '' then msg := TerrMan[GB^.map[X,Y].Terr].Name;
{$ENDIF PATCH_I18N}
{$IFDEF SDLMODE}
			CMessage( msg , ZONE_TargetInfo.GetRect() , InfoGreen );
{$ELSE}
			CMessage( msg , ZONE_Info , TerrainGreen );
{$ENDIF}
		end else begin
{$IFDEF SDLMODE}
{$IFDEF PATCH_I18N}
			CMessage( I18N_MsgString('DisplayTileInfo','UNKNOWN') , ZONE_TargetInfo.GetRect() , InfoGreen );
{$ELSE PATCH_I18N}
			CMessage( 'UNKNOWN' , ZONE_TargetInfo.GetRect() , InfoGreen );
{$ENDIF PATCH_I18N}
{$ELSE}
{$IFDEF PATCH_I18N}
			CMessage( I18N_MsgString('DisplayTileInfo','UNKNOWN') , ZONE_Info , TerrainGreen );
{$ELSE PATCH_I18N}
			CMessage( 'UNKNOWN' , ZONE_Info , TerrainGreen );
{$ENDIF PATCH_I18N}
{$ENDIF}
		end;

		LOOKER_Gear := Nil;

	end else if N = 1 then begin
		Mek := FindVisibleGear( GB , X , Y , 1 );
{$IFDEF SDLMODE}
		{ If we aren't showing empty tiles, this is getting called from outside }
		{ of gflooker, so draw the infobox border. }
		if not ShowEMpty then InfoBox( ZONE_TargetInfo.GetRect() );
		DisplayTargetInfo( Mek , gb, ZONE_TargetInfo );
{$ELSE}
		DisplayGearInfo( Mek , gb, ZONE_Info );
{$ENDIF}
		LOOKER_Gear := Mek;

	end else if N > 1 then begin
		TMM := CreateTileMechaMenu( GB , X , Y , True );
{$IFDEF SDLMODE}
		{ If we aren't showing empty tiles, this is getting called from outside }
		{ of gflooker, so draw the infobox border. }
		if not ShowEMpty then InfoBox( ZONE_TargetInfo.GetRect() );
		DisplayMenu( TMM , Nil );
{$ELSE}
		DisplayMenu( TMM );
{$ENDIF}
		DisposeRPGMenu( TMM );
		LOOKER_Gear := Nil;

	end;

end;

Function CoverDesc( C: Integer ): String;
	{ Return a string telling how much cover the target has. }
begin
	if C < 0 then begin
		CoverDesc := 'X';
	end else begin
		CoverDesc := BStr( C );
	end;
end;

Function FindNextTarget( GB: GameBoardPtr; Origin: GearPtr ): GearPtr;
	{ ORIGIN is looking for a new target. Return the next visible enemy found. }
var
	M,NextTarget,FirstTarget: GearPtr;
	PickNext: Boolean;
begin
	{ If we've already selected an enemy, find the next one from that point. }
{$IFDEF PATCH_GH}
	if (NIL = LOOKER_LastGearSelected) or (LOOKER_LastGearSelected^.G <= GG_DisposeGear) then begin
		if (NIL <> LOOKER_Gear) and (GG_DisposeGear < LOOKER_Gear^.G) then begin
			LOOKER_LastGearSelected := LOOKER_Gear;
		end else begin
			LOOKER_LastGearSelected := NIL;
		end;
	end;
	if (NIL = Origin) or (Origin^.G <= GG_DisposeGear) then Exit(NIL);
{$ELSE PATCH_GH}
	if ( LOOKER_LastGearSelected = Nil ) and ( LOOKER_Gear <> Nil ) then LOOKER_LastGearSelected := LOOKER_Gear;
{$ENDIF PATCH_GH}

	{ Cycle through all the models on the map looking for a visible, operational enemy. }
	M := GB^.Meks;
	NextTarget := Nil;
	PickNext := False;
	FirstTarget := Nil;
	while M <> Nil do begin
{$IFDEF PATCH_GH}
		if (GG_DisposeGear < M^.G) then begin
{$ENDIF PATCH_GH}
		{ If M fits our target criteria, check it to see what's going on. }
		if OnTheMap( M ) and AreEnemies( GB , Origin , M ) and GearOperational( M ) and MekCanSeeTarget( GB , Origin , M ) then begin
{$IFDEF PATCH_CHEAT}
			if not(Cheat_DoNotTargetMaterial) or ((GG_Mecha = M^.G) or (GG_Character = M^.G)) then begin
{$ENDIF PATCH_CHEAT}
			{ If M is the target we started with, set the flag to pick the next }
			{ target encountered. }
			if M = LOOKER_LastGearSelected then begin
				PickNext := True;
			end else if PickNext then begin
				NextTarget := M;
				PickNext := False;
			end;
			if FirstTarget = Nil then FirstTarget := M;
{$IFDEF PATCH_CHEAT}
			end;
{$ENDIF PATCH_CHEAT}
		end;
{$IFDEF PATCH_GH}
		end;
{$ENDIF PATCH_GH}

		M := M^.Next;
	end;
	{ If NextTarget = Nil, either we started with no target or the target we had }
	{ was the last target in the list. So, go with the first target found. }
	if NextTarget = Nil then NextTarget := FirstTarget;
	LOOKER_LastGearSelected := NextTarget;
	FindNextTarget := NextTarget;
end;

Function TrueLooker( GB: GameBoardPtr; X , Y: Integer ): Boolean;
	{ Scan the map, starting at location X,Y. }
	{ Return TRUE if this procedure is exited with the space bar, }
	{ FALSE if it is exited with the ESC key. }
	{ If Mek <> Nil, do range calculations from that spot. }
	{ If WPN <> Nil, allow weapon selection. }
var
{$IFDEF PATCH_GH}
	N: Integer;
	MekNum: LongInt;
	R_type: String;
{$ELSE PATCH_GH}
	N,MekNum: Integer;
{$ENDIF PATCH_GH}
	TMM: RPGMenuPtr;
	A: Char;
	P: Point;
{$IF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
	Target_X,Target_Y: Integer;
	flag_mouse: Boolean;
{$ENDIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
	Procedure RepositionCursor( D: Integer );
	begin
		RedrawTile( gb, X , Y );
		if OnTheMap( X + AngDir[ D , 1 ] , Y + AngDir[ D , 2 ] ) then begin
			X := X + AngDir[ D , 1 ];
			Y := Y + AngDir[ D , 2 ];
{$IF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
			RedrawTile( GB , Target_X , Target_Y );
			Target_X := X;
			Target_Y := Y;
			flag_mouse := False;
{$ENDIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
		end;
	end;
{$IFDEF PATCH_GH}
	Procedure Make_LOOKER_Desc( T_X , T_Y: Integer );
	var
		R: Integer;
  {$IFDEF PATCH_CHEAT}
		O_X, O_Y, O_Z: Integer;
		C1, C2: Integer;
  {$ELSE PATCH_CHEAT}
		C: Integer;
  {$ENDIF PATCH_CHEAT}
	begin
		LOOKER_Desc := '';
		R_type := ' ';
		if ( NIL <> LOOKER_Origin ) and OnTheMap( LOOKER_Origin ) then begin
			R := Range_with_Scale( GB^.Scale , LOOKER_Origin , T_X , T_Y );
			R_type := ':';
  {$IFDEF PATCH_CHEAT}
			O_X := NAttValue( LOOKER_Origin^.NA , NAG_Location , NAS_X );
			O_Y := NAttValue( LOOKER_Origin^.NA , NAG_Location , NAS_Y );
			O_Z := MekAltitude( GB , LOOKER_Origin );
			if Cheat_Show_RangeCover then begin
				C1 := CalcObscurement( O_X , O_Y , TerrMan[ GB^.Map[ O_X , O_Y ].terr ].Altitude , T_X , T_Y , TerrMan[ GB^.Map[ T_X , T_Y ].terr ].Altitude , GB );
				C2 := CalcObscurement( T_X , T_Y , TerrMan[ GB^.Map[ T_X , T_Y ].terr ].Altitude , O_X , O_Y , TerrMan[ GB^.Map[ O_X , O_Y ].terr ].Altitude , GB );
			end else begin
				C1 := CalcObscurement( LOOKER_Origin , T_X , T_Y , GB );
			end;
			if Cheat_Range_Colored then begin
				if ( NIL <> LOOKER_Gear ) then begin
					if MekCanSeeTarget( GB , FindRoot( LOOKER_Gear ) , LOOKER_Origin ) then begin
						R_type := '=';
					end else begin
						R_type := '*';
					end;
				end;
			end;
			if Cheat_Range_with_Altitude then begin
				if ( NIL <> LOOKER_Gear ) then begin
					R := Range_with_Scale( GB , LOOKER_Origin , LOOKER_Gear );
					C1 := CalcObscurement( LOOKER_Origin , LOOKER_Gear , GB );
					C2 := CalcObscurement( LOOKER_Gear , LOOKER_Origin , GB );
				end else begin
					R := Range_with_Scale( GB , LOOKER_Origin , T_X , T_Y , TerrMan[ GB^.Map[ T_X , T_Y ].terr ].Altitude );
					C1 := CalcObscurement( O_X , O_Y , O_Z , T_X , T_Y , TerrMan[ GB^.Map[ T_X , T_Y ].terr ].Altitude , GB );
					C2 := CalcObscurement( T_X , T_Y , TerrMan[ GB^.Map[ T_X , T_Y ].terr ].Altitude , O_X , O_Y , O_Z , GB );
				end;
			end;
			if Cheat_Show_RangeCover then begin
				LOOKER_Desc := 'Range: ' + BStr( R ) + '  Cover' + R_type + ' ' + CoverDesc( C1 ) + ',' + CoverDesc( C2 );
			end else begin
				LOOKER_Desc := 'Range: ' + BStr( R ) + '  Cover' + R_type + ' ' + CoverDesc( C1 );
			end;
  {$ELSE PATCH_CHEAT}
			C := CalcObscurement( LOOKER_Origin , T_X , T_Y , GB );
			LOOKER_Desc := 'Range: ' + BStr( R ) + '  Cover' + R_type + ' ' + CoverDesc( C );
  {$ENDIF PATCH_CHEAT}
		end;
	end;
{$ENDIF PATCH_GH}
{$IF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
var
	M: Point;
{$ENDIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
begin
	{ Error check- make sure the start point is on the screen. }
	if not OnTheMap(X,Y) then begin
{$IFDEF PATCH_GH}
		LOOKER_Gear := FindNextTarget( GB , LOOKER_Origin );
		if ( NIL <> LOOKER_Gear ) then begin
			X := NAttValue( LOOKER_Gear^.NA , NAG_Location , NAS_X );
			Y := NAttValue( LOOKER_Gear^.NA , NAG_Location , NAS_Y );
		end;
		if ( not OnTheMap(X,Y) ) and ( NIL <> LOOKER_Origin ) then begin
			X := NAttValue( LOOKER_Origin^.NA , NAG_Location , NAS_X );
			Y := NAttValue( LOOKER_Origin^.NA , NAG_Location , NAS_Y );
		end;
		if not OnTheMap(X,Y) then begin
			X := 1;
			Y := 1;
		end;
{$ELSE PATCH_GH}
		X := 1;
		Y := 1;
{$ENDIF PATCH_GH}
	end;

{$IF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
	Target_X := X;
	Target_Y := Y;
	flag_mouse := False;
	MouseAtTile( GB , Target_X , Target_Y );
	RedrawTile( GB , Target_X , Target_Y );
{$ENDIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}

	LOOKER_LastGearSelected := Nil;
	LOOKER_Gear := Nil;

{$IFDEF PATCH_GH}
	if (NIL <> LOOKER_Origin) and (GG_DisposeGear < LOOKER_Origin^.G) then begin
		P := GearCurrentLocation( LOOKER_Origin );
	end else begin
		LOOKER_Origin := NIL;
	end;
	if (NIL <> LOOKER_Gear) and (GG_DisposeGear < LOOKER_Gear^.G) then begin
	end else begin
		LOOKER_Gear := NIL;
	end;
	if (NIL <> LOOKER_Weapon) and (GG_DisposeGear < LOOKER_Weapon^.G) then begin
	end else begin
		LOOKER_Weapon := NIL;
	end;
{$ELSE PATCH_GH}
	if LOOKER_Origin <> Nil then P := GearCurrentLocation( LOOKER_Origin );
{$ENDIF PATCH_GH}

	{ Start going here. }
	repeat
		{ Display info on the selected tile. }
{$IF DEFINED(ASCII_SDL)}
		GHFlip;
{$ELSEIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
		Make_LOOKER_Desc( Target_X , Target_Y );
		if flag_mouse then begin
			SDLCombatDisplay( GB );
			RedrawTile( GB , Target_X , Target_Y );
			MouseAtTile( GB , Target_X , Target_Y );

			LOOKER_GB := GB;
			if ( NIL <> LOOKER_Origin ) then begin
				IndicateTile( GB , LOOKER_Origin , False );
			end;
			GFLRedraw;
			DisplayTileInfo( GB , Target_X , Target_Y, True );
			GHFlip;
		end;
{$ENDIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
{$IFNDEF SDLMODE}
  {$IFDEF PATCH_GH}
		DisplayTileInfo( GB , X , Y, True );
		Make_LOOKER_Desc( X , Y );
		if ( ':' = R_type ) then begin
			CMessage( LOOKER_Desc , ZONE_Clock , InfoGreen );
		end else if ( '=' = R_type ) then begin
			CMessage( LOOKER_Desc , ZONE_Clock , InfoGreen );
		end else if ( '*' = R_type ) then begin
			CMessage( LOOKER_Desc , ZONE_Clock , InfoHiLight );
		end else begin
		end;
  {$ELSE PATCH_GH}
		DisplayTileInfo( GB , X , Y, True );
		if ( LOOKER_Origin <> Nil ) and OnTheMap( LOOKER_Origin ) then begin
			if LOOKER_Gear = Nil then begin
				CMessage( 'Range: ' + BStr( ScaleRange( Range(LOOKER_Origin,X,Y) , GB^.Scale ) ) + '   Cover: '+CoverDesc( CalcObscurement( LOOKER_Origin , X , Y , gb )) , ZONE_Clock , InfoGreen );
			end else begin
    {$IFDEF PATCH_CHEAT}
				if Cheat_Range_Colored and not MekCanSeeTarget( GB , FindRoot( LOOKER_Gear ) , LOOKER_Origin ) then begin
					CMessage( 'Range* ' + BStr( ScaleRange( Range(gb,LOOKER_Origin,LOOKER_Gear) , GB^.Scale )) + '   Cover* '+CoverDesc( CalcObscurement( LOOKER_Origin , LOOKER_Gear , gb )) , ZONE_Clock , InfoHiLight );
				end else begin
					CMessage( 'Range: ' + BStr( ScaleRange( Range(gb,LOOKER_Origin,LOOKER_Gear) , GB^.Scale )) + '   Cover: '+CoverDesc( CalcObscurement( LOOKER_Origin , LOOKER_Gear , gb )) , ZONE_Clock , InfoGreen );
				end;
    {$ELSE PATCH_CHEAT}
				CMessage( 'Range: ' + BStr( ScaleRange( Range(gb,LOOKER_Origin,LOOKER_Gear) , GB^.Scale )) + '   Cover: '+CoverDesc( CalcObscurement( LOOKER_Origin , LOOKER_Gear , gb )) , ZONE_Clock , InfoGreen );
    {$ENDIF PATCH_CHEAT}
			end;
		end;
  {$ENDIF PATCH_GH}
{$ENDIF}

		{ Display info on the selected weapon. }
{$IFNDEF SDLMODE}
		if LOOKER_Weapon <> Nil then WeaponDisplay;
{$ENDIF}

		{ Indicate origin and target squares. }
{$IFDEF SDLMODE}
		if ( LOOKER_Origin <> Nil ) then IndicateTile( GB , LOOKER_Origin , False );
		IndicateTile( GB , X , Y , TerrMan[ GB^.Map[ X , Y ].terr ].Altitude , True );
{$ELSE}
		if ( LOOKER_Origin <> Nil ) and ( not NeedsRecentering( P.X , P.Y ) ) then IndicateTile( GB , LOOKER_Origin );
		IndicateTile( GB , X , Y );
{$ENDIF}

		A := RPGKey;

{$IFDEF PATCH_GH}
		if (KBD_NONE = A) then begin
		end else
{$ENDIF PATCH_GH}
		if A = KeyMap[ KMC_North ].KCode then begin
			RepositionCursor( 6 );

		end else if A = KeyMap[ KMC_South ].KCode then begin
			RepositionCursor( 2 );

		end else if A = KeyMap[ KMC_West ].KCode then begin
			RepositionCursor( 4 );

		end else if A = KeyMap[ KMC_East ].KCode then begin
			RepositionCursor( 0 );

		end else if A = KeyMap[ KMC_NorthEast ].KCode then begin
			RepositionCursor( 7 );

		end else if A = KeyMap[ KMC_SouthWest ].KCode then begin
			RepositionCursor( 3 );

		end else if A = KeyMap[ KMC_NorthWest ].KCode then begin
			RepositionCursor( 5 );

		end else if A = KeyMap[ KMC_SouthEast ].KCode then begin
			RepositionCursor( 1 );

		end else if ( A = KeyMap[ KMC_SwitchWeapon ].KCode ) and ( LOOKER_Weapon <> Nil ) and ( LOOKER_Origin <> Nil ) then begin
			LOOKER_Weapon := FindNextWeapon( GB , LOOKER_Origin , LOOKER_Weapon , Range( LOOKER_Origin , X , Y ) );

		end else if ( A = KeyMap[ KMC_SwitchTarget ].KCode ) and ( LOOKER_Weapon <> Nil ) and ( LOOKER_Origin <> Nil ) then begin
			RedrawTile( gb, X , Y );
			LOOKER_Gear := FindNextTarget( GB , LOOKER_Origin );
			if LOOKER_Gear <> Nil then begin
				X := NATtValue( LOOKER_Gear^.NA , NAG_Location , NAS_X );
				Y := NATtValue( LOOKER_Gear^.NA , NAG_Location , NAS_Y );
			end;
{$IF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
			if OnTheMap( X , Y ) then begin
				RedrawTile( GB , Target_X , Target_Y );
				Target_X := X;
				Target_Y := Y;
			end;
			flag_mouse := False;
{$ENDIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}

		end else if ( A = KeyMap[ KMC_SwitchBV ].KCode ) and ( LOOKER_Weapon <> Nil ) and ( LOOKER_Origin <> Nil ) then begin
			DoSwitchBV;

		end else if ( A = KeyMap[ KMC_CalledShot ].KCode ) and ( LOOKER_Weapon <> Nil ) and ( LOOKER_Origin <> Nil ) then begin
			LOOKER_CallShot := not LOOKER_CallShot;

		end else if A = KeyMap[ KMC_ExamineMap ].KCode then begin
			A := #27;

		end else if A = KeyMap[ KMC_Attack ].KCode then begin
			A := ' ';

{$IFDEF SDLMODE}
		end else if A = #8 then begin
			A := #27;
  {$IFDEF PATCH_GH}
		end else if A = #13 then begin
			A := ' ';
		end else if A = #10 then begin
			A := ' ';
  {$ENDIF PATCH_GH}

  {$IFDEF PATCH_GH}
		end else if ( A = RPK_TimeEvent ) and not( flag_mouse ) then begin
  {$ELSE PATCH_GH}
		end else if A = RPK_TimeEvent then begin
  {$ENDIF PATCH_GH}
			LOOKER_GB := GB;
  {$IFDEF PATCH_GH}
			DisplayTileInfo( GB , X , Y, True );
			Make_LOOKER_Desc( X , Y );
  {$ELSE PATCH_GH}
			if ( LOOKER_Origin <> Nil ) and OnTheMap( LOOKER_Origin ) then begin
				if LOOKER_Gear = Nil then begin
					LOOKER_Desc := 'Range: ' + BStr( ScaleRange( Range(LOOKER_Origin,X,Y) , GB^.Scale ) ) + '   Cover: '+CoverDesc( CalcObscurement( LOOKER_Origin , X , Y , gb ));
				end else begin
    {$IFDEF PATCH_CHEAT}
					if Cheat_Range_Colored and not MekCanSeeTarget( GB , FindRoot( LOOKER_Gear ) , LOOKER_Origin ) then begin
						LOOKER_Desc := 'Range* ' + BStr( ScaleRange( Range(LOOKER_Origin,X,Y) , GB^.Scale ) ) + '   Cover* '+CoverDesc( CalcObscurement( LOOKER_Origin , X , Y , gb ));
					end else begin
						LOOKER_Desc := 'Range: ' + BStr( ScaleRange( Range(LOOKER_Origin,X,Y) , GB^.Scale ) ) + '   Cover: '+CoverDesc( CalcObscurement( LOOKER_Origin , X , Y , gb ));
					end;
    {$ELSE PATCH_CHEAT}
					LOOKER_Desc := 'Range: ' + BStr( ScaleRange( Range(LOOKER_Origin,X,Y) , GB^.Scale ) ) + '   Cover: '+CoverDesc( CalcObscurement( LOOKER_Origin , X , Y , gb ));
    {$ENDIF PATCH_CHEAT}
				end;
			end;
  {$ENDIF PATCH_GH}
			GFLRedraw;
			DisplayTileInfo( GB , X , Y, True );
			ghflip();
{$ENDIF}
{$IFDEF PATCH_CHEAT}
		end else if Cheat_NPC_Edit and (A = KeyMap[ KMC_SelectPortrait ].KCode) then begin
			if (LOOKER_Gear <> Nil) and (LOOKER_Gear^.G = GG_Character) then begin
				SelectPortrait( GB , LOOKER_Gear );
			end;
		end else if Cheat_NPC_Edit and (A = KeyMap[ KMC_RenameMecha ].KCode) then begin
			if (LOOKER_Gear <> Nil) then Rename_Mecha( GB , LOOKER_Gear );
		end else if Cheat_NPC_Edit and Cheat_MenuOrder_Edit and (A = KeyMap[ KMC_EditMenuOrder ].KCode) then begin
			if (LOOKER_Gear <> Nil) then begin
  {$IFDEF SDLMODE}
				MechaPartBrowser( LOOKER_Gear , @GFLRedraw )
  {$ELSE SDLMODE}
				MechaPartBrowser( LOOKER_Gear )
  {$ENDIF SDLMODE}
			end else begin
				LOOKER_Gear := NewGear(Nil);
				LOOKER_Gear^.G := GG_Scene;
				LOOKER_Gear^.InvCom := GB^.meks;
  {$IFDEF SDLMODE}
				MechaPartBrowser( LOOKER_Gear , @GFLRedraw );
  {$ELSE SDLMODE}
				MechaPartBrowser( LOOKER_Gear );
  {$ENDIF SDLMODE}
				GB^.meks := LOOKER_Gear^.InvCom;
				LOOKER_Gear^.InvCom := Nil;
				DisposeGear(LOOKER_Gear);
			end;
{$ENDIF PATCH_CHEAT}
{$IF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
		end else if ( RPK_MouseButton = A ) then begin
			if IsMouseOnMap and ( not IsMenuActive ) then begin
				flag_mouse := True;
				RedrawTile( GB , X , Y );
				M := MouseMapPos;
				if OnTheMap( M.X , M.Y ) then begin
					X := M.X;
					Y := M.Y;
					Target_X := M.X;
					Target_Y := M.Y;
				end;
			end;
			A := ' ';

		end else if ( RPK_RightButton = A ) then begin
			A := #27;

		end else if ( RPK_MouseMotion = A ) then begin
			if IsMouseOnMap and ( not IsMenuActive ) then begin
				flag_mouse := True;
				RedrawTile( GB , Target_X , Target_Y );
				M := MouseMapPos;
				if OnTheMap( M.X , M.Y ) then begin
					Target_X := M.X;
					Target_Y := M.Y;
				end;
			end;
{$ENDIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}

		end;

	until (A = ' ') or (A = #27) or (A = #10);

	{ Restore the display. }
	RedrawTile( gb, X , Y );
{$IF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
	RedrawTile( GB, Target_X , Target_Y );
{$ENDIF DEFINED(PATCH_GH) and DEFINED(SDLMODE)}
	if LOOKER_Origin <> Nil then RedrawTile( gb, LOOKER_Origin );
{$IFNDEF SDLMODE}
	UpdateCombatDisplay( GB );
{$ENDIF}

	{ Store the values in the global variables. }
	LOOKER_X := X;
	LOOKER_Y := Y;

	N := NumVisibleGears( GB , X , Y );
	if N = 1 then begin
		LOOKER_Gear := FindVisibleGear( GB , X , Y , 1 );

{$IFDEF PATCH}
	end else if (N > 1) and (A = ' ') then begin
{$ELSE}
	end else if N > 1 then begin
{$ENDIF}
		TMM := CreateTileMechaMenu( GB , X , Y , Looker_Weapon = Nil );
		if TMM^.NumItem > 1 then begin
{$IFDEF PATCH_CHEAT}
			if Cheat_LookInfo and not(LOOKER_CallShot and Cheat_CallShot and Cheat_CallShot_OmitLookInfo) then begin
				repeat
  {$IFDEF PATCH_GH}
					LOOKER_Gear := NIL;
					Make_LOOKER_Desc( X , Y );
  {$ENDIF PATCH_GH}
  {$IFDEF SDLMODE}
					MekNum := SelectMenu( TMM , @GFLRedraw );
  {$ELSE SDLMODE}
					MekNum := SelectMenu( TMM );
  {$ENDIF SDLMODE}
					if MekNum <> -1 then begin
  {$IFDEF PATCH_GH}
						LOOKER_Gear := FindVisibleGear( GB , X , Y , MekNum );
						Make_LOOKER_Desc( X , Y );
  {$ENDIF PATCH_GH}
  {$IF DEFINED(ASCII_SDL)}
    {$IFDEF PATCH_GH}
						if ( ':' = R_type ) then begin
							CMessage( LOOKER_Desc , ZONE_Clock , InfoGreen );
						end else if ( '=' = R_type ) then begin
							CMessage( LOOKER_Desc , ZONE_Clock , InfoGreen );
						end else if ( '*' = R_type ) then begin
							CMessage( LOOKER_Desc , ZONE_Clock , InfoHiLight );
						end else begin
						end;
    {$ENDIF PATCH_GH}
						GHFlip;
						DisplayGearInfo( FindVisibleGear( GB , X , Y , MekNum ) , GB , ZONE_Info );
						A := RPGKey;
  {$ELSEIF DEFINED(SDLMODE)}
						SDLCombatDisplay( GB );
						InfoBox( ZONE_TargetInfo.GetRect() );
						DisplayTargetInfo( FindVisibleGear( GB , X , Y , MekNum ) , GB , ZONE_TargetInfo );
    {$IFDEF PATCH_GH}
						InfoBox( ZONE_TargetDistance.GetRect() );
						CMessage( LOOKER_Desc , ZONE_TargetDistance.GetRect() , InfoHiLight );
    {$ENDIF PATCH_GH}
						GHFlip;
    {$IFDEF PATCH_GH}
						repeat
							A := RPGKey;
						until ( ( RPK_TimeEvent <> A ) and ( RPK_MouseMotion <> A ) );

						if A = #13 then begin
							A := ' ';
						end else if A = #10 then begin
							A := ' ';
						end;
    {$ELSE PATCH_GH}
						repeat
							A := RPGKey;
						until A <> RPK_TimeEvent;
    {$ENDIF PATCH_GH}
  {$ELSE SDLMODE}
						DisplayGearInfo( FindVisibleGear( GB , X , Y , MekNum ) , GB , ZONE_Info );
    {$IFDEF PATCH_GH}
						if ( ':' = R_type ) then begin
							CMessage( LOOKER_Desc , ZONE_Clock , InfoGreen );
						end else if ( '=' = R_type ) then begin
							CMessage( LOOKER_Desc , ZONE_Clock , InfoGreen );
						end else if ( '*' = R_type ) then begin
							CMessage( LOOKER_Desc , ZONE_Clock , InfoHiLight );
						end else begin
						end;
    {$ENDIF PATCH_GH}
						A := RPGKey;
  {$ENDIF SDLMODE}
  {$IFDEF PATCH_GH}
						if (KBD_NONE = A) then begin
						end else
  {$ENDIF PATCH_GH}
						if (A = KeyMap[ KMC_ExamineMap ].KCode) or (A = #8) then A := #27
						else if A = KeyMap[ KMC_Attack ].KCode then A := ' ';

						if (A = #27) then A := 'A';
					end;
				until (MekNum = -1) or (A = ' ') or (A = #27) or (A = #10);
				if MekNum = -1 then A := #27;
			end else begin
  {$IFDEF SDLMODE}
				MekNum := SelectMenu( TMM , @GFLRedraw );
  {$ELSE SDLMODE}
				MekNum := SelectMenu( TMM );
  {$ENDIF SDLMODE}
  {$IFDEF PATCH_GH}
				if MekNum = -1 then A := #27;
  {$ENDIF PATCH_GH}
			end;
{$ELSE PATCH_CHEAT}
  {$IFDEF SDLMODE}
			MekNum := SelectMenu( TMM , @GFLRedraw );
  {$ELSE SDLMODE}
			MekNum := SelectMenu( TMM );
  {$ENDIF SDLMODE}
  {$IFDEF PATCH_GH}
			if MekNum = -1 then A := #27;
  {$ENDIF PATCH_GH}
{$ENDIF PATCH_CHEAT}
		end else if TMM^.NumItem > 0 then begin
			MekNum := TMM^.FirstItem^.Value;
		end else begin
			MekNum := -1;
		end;
		DisposeRPGMenu( TMM );

		if MekNum <> -1 then LOOKER_Gear := FindVisibleGear( GB , X , Y , MekNum )
		else LOOKER_Gear := Nil;

	end else begin
		LOOKER_Gear := Nil;
	end;

	{ Return TRUE if a space was pressed, FALSE otherwise. }
	TrueLooker := ( A = ' ' ) or ( A = #10 );
end;

Function LookAround( GB: GameBoardPtr; Mek: GearPtr ): Boolean;
	{ This function just calls the above one with the location of }
	{ the specified mek. }
var
	X,Y: Integer;
begin
{$IFDEF PATCH_GH}
	if (NIL = Mek) or (Mek^.G <= GG_DisposeGear) then begin
		Mek := NIL;
	end;
{$ENDIF PATCH_GH}

	LOOKER_Origin := Mek;
	LOOKER_Weapon := Nil;

	if Mek <> Nil then begin
		X := NAttValue( Mek^.NA , NAG_Location, NAS_X );
		Y := NAttValue( Mek^.NA , NAG_Location, NAS_Y );
	end else begin
		X := 1;
		Y := 1;
	end;

	LookAround := TrueLooker( GB , X , Y );
end;

Function SelectTarget( GB: GameBoardPtr; Mek: GearPtr; var Wpn: GearPtr; var CallShot: boolean; var RapidFire: Integer ): Boolean;
	{ This function just calls LookAround with the location of }
	{ the specified mek and its current target. }
	{ Record the target selected as this mecha's target. }
var
	T: GearPtr;		{ The Target }
	X,Y: Integer;
	FunResult: Boolean;	{ Function Result }
begin
{$IFDEF PATCH_GH}
	if (NIL = Mek) or (Mek^.G <= GG_DisposeGear) then Exit(False);
	if (NIL = Wpn) or (Wpn^.G <= GG_DisposeGear) then Exit(False);
{$ENDIF PATCH_GH}

	LOOKER_Origin := Mek;
	LOOKER_Weapon := Wpn;
	LOOKER_CallShot := CallShot;
	LOOKER_RapidFire := RapidFire;

	{ Get the default values from this mek. }
	T := LocateMekByUID( GB , NAttValue( Mek^.NA , NAG_EpisodeData , NAS_Target ) );

	{ If this mek has a target, start out the targeting cursor in the }
	{ target's square. If it has no target, start the targeting cursor }
	{ in the mek's own square. }
	if ( T <> Nil ) and MekCanSeeTarget( gb , Mek , T ) and GearOperational( T ) then begin
		X := NAttValue( T^.NA , NAG_Location, NAS_X );
		Y := NAttValue( T^.NA , NAG_Location, NAS_Y );
	end else if LOOKER_AutoSelect then begin
		T := SeekTarget( GB , Mek );
		if T <> Nil then begin
			X := NAttValue( T^.NA , NAG_Location, NAS_X );
			Y := NAttValue( T^.NA , NAG_Location, NAS_Y );
		end else begin
			X := NAttValue( Mek^.NA , NAG_Location , NAS_X );
			Y := NAttValue( Mek^.NA , NAG_Location , NAS_Y );
		end;
	end else begin
		X := NAttValue( Mek^.NA , NAG_Location , NAS_X );
		Y := NAttValue( Mek^.NA , NAG_Location , NAS_Y );
	end;

	{ Call the look around procedure. }
	FunResult := TrueLooker( GB , X , Y );

	{ If the targeting wasn't cancelled, record the target. }
	if FunResult and ( LOOKER_Gear <> Nil ) and ( FindRoot( LOOKER_Gear ) <> Mek ) then begin
		SetNAtt( Mek^.NA , NAG_EpisodeData , NAS_Target , NAttValue( LOOKER_Gear^.NA , NAG_EpisodeData , NAS_UID ) );
	end;

	{ Set the values of the VAR parameters. }
	Wpn := LOOKER_Weapon;
	CallShot := LOOKER_CallShot;
	RapidFire := LOOKER_RapidFire;

	{ Return the value. }
	SelectTarget := FunResult;
end;

{$IFDEF PATCH_HEART}
Function LookAround4QRL( Camp: CampaignPtr; GB: GameBoardPtr; Mek: GearPtr ): Boolean;
  {$IFDEF SDLMODE}
var
	flag_mouse: Boolean;
  {$ENDIF SDLMODE}

	Procedure RepositionCursor( D: Integer );
	begin
		RedrawTile( GB, LookAround4QRL_X , LookAround4QRL_Y );
		if OnTheMap( LookAround4QRL_X + AngDir[ D , 1 ] , LookAround4QRL_Y + AngDir[ D , 2 ] ) then begin
			LookAround4QRL_X := LookAround4QRL_X + AngDir[ D , 1 ];
			LookAround4QRL_Y := LookAround4QRL_Y + AngDir[ D , 2 ];
  {$IFDEF SDLMODE}
			RedrawTile( GB , LookAround4QRL_Target_X , LookAround4QRL_Target_Y );
			LookAround4QRL_Target_X := LookAround4QRL_X;
			LookAround4QRL_Target_Y := LookAround4QRL_Y;
			flag_mouse := False;
  {$ENDIF SDLMODE}
		end;
	end;

var
	A: Char;
  {$IFDEF SDLMODE}
	M: Point;
  {$ENDIF SDLMODE}
begin
	LookAround4QRL := False;
  {$IFDEF PATCH_GH}
	if ( NIL = Mek ) or ( Mek^.G <= GG_DisposeGear ) then begin
		Mek := NIL;
	end;
  {$ENDIF PATCH_GH}

	if ( ( 0 = LookAround4QRL_X ) and ( 0 = LookAround4QRL_Y ) ) or ( not LookAround4QRL_FixedTarget ) then begin
		if ( NIL <> Mek ) then begin
			LookAround4QRL_X := NAttValue( Mek^.NA , NAG_Location, NAS_X );
			LookAround4QRL_Y := NAttValue( Mek^.NA , NAG_Location, NAS_Y );
		end;
	end;

  {$IFDEF SDLMODE}
	if ( ( 0 = LookAround4QRL_Target_X ) and ( 0 = LookAround4QRL_Target_Y ) ) or ( not LookAround4QRL_FixedTarget ) then begin
		LookAround4QRL_Target_X := LookAround4QRL_X;
		LookAround4QRL_Target_Y := LookAround4QRL_Y;
	end;
	flag_mouse := False;
	MouseAtTile( GB , LookAround4QRL_Target_X , LookAround4QRL_Target_Y );
	RedrawTile( GB , LookAround4QRL_Target_X , LookAround4QRL_Target_Y );
  {$ENDIF SDLMODE}

	if Flag_Pause_LookAround4QRL then begin
  {$IFDEF PATCH_I18N}
		DialogMsg( I18N_MsgString('LookAround4QRL','Now in a Pause') );
  {$ELSE PATCH_I18N}
		DialogMsg( 'Now in a Pause' );
  {$ENDIF PATCH_I18N}
	end;

	repeat
  {$IFDEF SDLMODE}
		LOOKER_GB := GB;
		GFLRedraw;
		DisplayTileInfo( GB , LookAround4QRL_Target_X , LookAround4QRL_Target_Y , True );
		if flag_mouse and ( LookAround4QRL_Target_X <> LookAround4QRL_X ) or ( LookAround4QRL_Target_Y <> LookAround4QRL_Y ) then begin
			MouseAtTile( GB , LookAround4QRL_Target_X , LookAround4QRL_Target_Y );
		end;
		if ( 0 < LookAround4QRL_X ) and ( 0 < LookAround4QRL_Y ) then begin
			IndicateTile( GB , LookAround4QRL_X , LookAround4QRL_Y , TerrMan[ GB^.Map[ LookAround4QRL_X , LookAround4QRL_Y ].terr ].Altitude , True );
		end;
		GHFlip;
  {$ELSE SDLMODE}
		DisplayTileInfo( GB , LookAround4QRL_X , LookAround4QRL_Y , True );
		IndicateTile( GB , LookAround4QRL_X , LookAround4QRL_Y );
  {$ENDIF SDLMODE}

		A := RPGKey_nonblocking();
  {$IFDEF PATCH_GH}
		if (KBD_NONE = A) then begin
		end else
  {$ENDIF PATCH_GH}
		if ( RPK_TimeEvent = A ) then begin

		end else if ( #27 = A ) then begin
			LookAround4QRL_FixedTarget := False;
			if Flag_Pause_LookAround4QRL then begin
  {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','Cancel Pause') );
  {$ELSE PATCH_I18N}
				DialogMsg( 'Cancel a Pause' );
  {$ENDIF PATCH_I18N}
				Flag_Pause_LookAround4QRL := False;
			end;

		end else if ( #13 = A ) then begin
			LookAround4QRL_FixedTarget := True;
			if Flag_Pause_LookAround4QRL then begin
  {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','Cancel Pause') );
  {$ELSE PATCH_I18N}
				DialogMsg( 'Cancel a Pause' );
  {$ENDIF PATCH_I18N}
				Flag_Pause_LookAround4QRL := False;
			end;

		end else if ( #10 = A ) then begin
			LookAround4QRL_FixedTarget := True;
			if Flag_Pause_LookAround4QRL then begin
  {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','Cancel Pause') );
  {$ELSE PATCH_I18N}
				DialogMsg( 'Cancel a Pause' );
  {$ENDIF PATCH_I18N}
				Flag_Pause_LookAround4QRL := False;
			end else begin
  {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','Pause') );
  {$ELSE PATCH_I18N}
				DialogMsg( 'Pause' );
  {$ENDIF PATCH_I18N}
				Flag_Pause_LookAround4QRL := True;
			end;

		end else if ( ' ' = A ) then begin
			LookAround4QRL_FixedTarget := True;
			if Flag_Pause_LookAround4QRL then begin
  {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','Step') );
  {$ELSE PATCH_I18N}
				DialogMsg( 'Step' );
  {$ENDIF PATCH_I18N}
				break;
			end else begin
  {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','Pause') );
  {$ELSE PATCH_I18N}
				DialogMsg( 'Pause' );
  {$ENDIF PATCH_I18N}
				Flag_Pause_LookAround4QRL := True;
			end;

  {$IFDEF SDLMODE}
		end else if ( RPK_MouseButton = A ) then begin
			flag_mouse := True;
			RedrawTile( GB , LookAround4QRL_X , LookAround4QRL_Y );
			M := MouseMapPos;
			if OnTheMap( M.X , M.Y ) then begin
				LookAround4QRL_X := M.X;
				LookAround4QRL_Y := M.Y;
				LookAround4QRL_Target_X := M.X;
				LookAround4QRL_Target_Y := M.Y;
			end;

		end else if ( RPK_RightButton = A ) then begin
			LookAround4QRL_FixedTarget := True;
			if Flag_Pause_LookAround4QRL then begin
    {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','Step') );
    {$ELSE PATCH_I18N}
				DialogMsg( 'Step' );
    {$ENDIF PATCH_I18N}
				break;
			end else begin
    {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','Pause') );
    {$ELSE PATCH_I18N}
				DialogMsg( 'Pause' );
    {$ENDIF PATCH_I18N}
				Flag_Pause_LookAround4QRL := True;
			end;

		end else if ( RPK_MouseMotion = A ) then begin
			flag_mouse := True;
			M := MouseMapPos;
			if OnTheMap( M.X , M.Y ) then begin
				if ( M.X <> LookAround4QRL_Target_X ) or ( M.Y <> LookAround4QRL_Target_Y ) then begin
					RedrawTile( GB , LookAround4QRL_Target_X , LookAround4QRL_Target_Y );
				end;
				LookAround4QRL_Target_X := M.X;
				LookAround4QRL_Target_Y := M.Y;
			end;
  {$ENDIF SDLMODE}

		end else if ( KeyMap[ KMC_North ].KCode = A ) then begin
			RepositionCursor( 6 );

		end else if ( KeyMap[ KMC_South ].KCode = A ) then begin
			RepositionCursor( 2 );

		end else if ( KeyMap[ KMC_West ].KCode = A ) then begin
			RepositionCursor( 4 );

		end else if ( KeyMap[ KMC_East ].KCode = A ) then begin
			RepositionCursor( 0 );

		end else if ( KeyMap[ KMC_NorthEast ].KCode = A ) then begin
			RepositionCursor( 7 );

		end else if ( KeyMap[ KMC_SouthWest ].KCode = A ) then begin
			RepositionCursor( 3 );

		end else if ( KeyMap[ KMC_NorthWest ].KCode = A ) then begin
			RepositionCursor( 5 );

		end else if ( KeyMap[ KMC_SouthEast ].KCode = A ) then begin
			RepositionCursor( 1 );

		end else if ( KeyMap[ KMC_QuitGame ].KCode = A ) then begin
			if DoAutoSave then PCSaveCampaign( Camp , Mek , True );
			GB^.QuitTheGame := True;
			break;

		end else if ( KeyMap[ KMC_SaveGame ].KCode = A ) then begin
			PCSaveCampaign( Camp , Mek , True );

		end else if ( KeyMap[ KMC_History ].KCode = A ) then begin
			DisplayConsoleHistory( GB );

		end else if ( KeyMap[ KMC_Always_GetPlayerInput ].KCode = A ) then begin
			if not Cheat_Always_GetPlayerInput then begin
				Cheat_Always_GetPlayerInput := True;
  {$IFDEF PATCH_I18N}
				DialogMsg( I18N_MsgString('LookAround4QRL','AlwaysGPI') );
  {$ELSE PATCH_I18N}
				DialogMsg( 'AlwaysGPI' );
  {$ENDIF PATCH_I18N}
				LookAround4QRL := True;
				Flag_Pause_LookAround4QRL := False;
			end;

  {$IFDEF DEBUG}
		end else if ( KeyMap[ KMC_CanSeeAll ].KCode = A ) then begin
			if DEBUG_CanSeeAll then DEBUG_CanSeeAll := False else DEBUG_CanSeeAll := True;
  {$ENDIF DEBUG}

		end else if ( 'd' = A ) then begin
			if DEBUG_EnableLuaDebugger then DEBUG_EnableLuaDebugger := False else DEBUG_EnableLuaDebugger := True;
			CallQRLdebugger( Mek , DEBUG_EnableLuaDebugger );

		end;
	until ( not Flag_Pause_LookAround4QRL );
end;

Procedure Init_LookAround4QRL;
begin
	Flag_GetMekInput_Forced2Pause := True;
	Flag_Pause_LookAround4QRL := True;

	LookAround4QRL_FixedTarget := False;
	LookAround4QRL_X := 0;
	LookAround4QRL_Y := 0;
  {$IFDEF SDLMODE}
	LookAround4QRL_Target_X := 0;
	LookAround4QRL_Target_Y := 0;
  {$ENDIF SDLMODE}
end;
{$ENDIF PATCH_HEART}



initialization
begin
{$IFDEF DEBUG}
	ErrorMessage_fork('DEBUG: gflooker.pp');
{$ENDIF DEBUG}
{$IFDEF PATCH_GH}
	LOOKER_Gear := NIL;
	LOOKER_LastGearSelected := NIL;
	LOOKER_Origin := NIL;
	LOOKER_Weapon := NIL;
	Attach_SmartPointer( 'LOOKER_Gear: GearPtr', @LOOKER_Gear );
	Attach_SmartPointer( 'LOOKER_LastGearSelected: GearPtr', @LOOKER_LastGearSelected );
	Attach_SmartPointer( 'LOOKER_Origin: GearPtr', @LOOKER_Origin );
	Attach_SmartPointer( 'LOOKER_Weapon: GearPtr', @LOOKER_Weapon );
  {$IFDEF SDLMODE}
	LOOKER_GB := NIL;
	Attach_SmartPointer( 'LOOKER_GB: GameBoardPtr', @LOOKER_GB );
  {$ENDIF SDLMODE}
{$ENDIF PATCH_GH}
{$IFDEF PATCH_HEART}
	Init_LookAround4QRL;
{$ENDIF PATCH_HEART}
end;

finalization
begin
{$IFDEF DEBUG}
	ErrorMessage_fork('DEBUG: gflooker.pp(finalization)');
{$ENDIF DEBUG}
end;

end.
